<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigItecalcfolha extends Base\MigItecalcfolha
{

    const DEFAULT_IDREFEVALOR = 'NORMAL';

    /**
     * @param $nrvinculom
     * @return \Folha\Entities\MigDepvinculo
     */
    public function setNrvinculom ($nrvinculom) {
        $nrvinculom = \Importacao\Logic\Validacoes::verificaChaveMae('GPE_VINCULOM', 'NRVINCULOM', ProjetoImportacao::getNrorg(), $nrvinculom);
        $this->nrvinculom = $nrvinculom;
    }

    /**
     * @param $nrcalculofolha
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setNrcalculofolha ($nrcalculofolha) {
        $nrcalculofolha = \Importacao\Logic\Validacoes::verificaChaveMae('FPA_CALCULOFOLHA', 'NRCALCULOFOLHA', ProjetoImportacao::getNrorg(), $nrcalculofolha);
        $this->nrcalculofolha = $nrcalculofolha;
    }

    /**
     * @param $nreventom
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setNreventom ($nreventom) {
        $nrorgPadrao = ProjetoImportacao::getNrorgPadrao();
        $evento = \Folha\Entities\FpaEventom::getObjectByWhere('NREVENTOM = ? AND NRORG = ?', array($nreventom, $nrorgPadrao));

        if (is_object($evento)) {
            $this->nreventom = $nreventom;
        } else {
            /*$nreventom = \Importacao\Logic\Validacoes::verificaChaveMae('FPA_EVENTOM', 'NREVENTOM', ProjetoImportacao::getNrorg(), $nreventom);*/
            $this->nreventom = $nreventom;
        }
    }

    /**
     * @param $vreventofolha
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setVreventofolha ($vreventofolha) {
        $vreventofolha = str_replace(',', '.', $vreventofolha);
        $this->vreventofolha = $vreventofolha;
    }

    /**
     * @param $vrreffolha
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setVrreffolha ($vrreffolha) {
        $vrreffolha = str_replace(',', '.', $vrreffolha);
        $this->vrreffolha = $vrreffolha;
    }

    /**
     * @param $idrefevalorcalc
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setIdrefevalorcalc ($idrefevalorcalc) {
        if (empty($idrefevalorcalc)) {
            $idrefevalorcalc = self::DEFAULT_IDREFEVALOR;
        }
        $this->idrefevalorcalc = $idrefevalorcalc;
    }

    /**
     * @param $dtocorrencia
     * @throws \Exception
     * @return \Folha\Entities\MigItecalcfolha
     */
    public function setDtocorrencia ($dtocorrencia) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtocorrencia)) {
            if (!empty($dtocorrencia)) {
                throw new \Exception("Dt. Ocorrência: Data '$dtocorrencia' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtocorrencia instanceof \DateTime)) {
            $dtocorrencia = DateUtil::getDataDeString($dtocorrencia);
        }

        $this->dtocorrencia = $dtocorrencia;
    }

    /**
     * @param $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigDepvinculo
     */
    public function setDtultatu ($dtultatu) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigDepvinculo
     */
    public function setDtinclusao ($dtinclusao) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

}