<?php
namespace Suprimentos\Logic\Compra;
use Geral\Entities\Filial;
use Geral\Util\Novocodigo;
use Geral\Entities\Solicita;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;

class NovaSolicitacao{

    //Insere Nova Solicitação
    public static function novaSolicita($nrorg, $idtiplan, $cdfilisoli){
        try{
            $filial = Filial::findOneByNrorgAndCdfilial($nrorg, $cdfilisoli);
            if($filial){
                $cdfilial = Ambiente::getCdFilial();
                $nrsolicmp = NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'SOLICOMP'.$cdfilisoli.$cdfilial, 1, 10);
                $solicita = new Solicita();
                $solicita->setNrorg($nrorg);
                $solicita->setNrsolicmp($nrsolicmp);

                if($filial->getCdfilcentcmp()){
                    $cdfilcent = $filial->getCdfilcentcmp();
                }else $cdfilcent = $cdfilisoli;

                $solicita->setCdfilcent($cdfilcent);
                $solicita->setIdtiplan($idtiplan);
                $solicita->setCdfilsoli($cdfilisoli);
                $solicita->setCdfillanca($cdfilial);
                $solicita->setCdoperador(Ambiente::getCdoperador());
                $solicita->setDtsolcmp(DateUtil::getDataAtual());
                $solicita->persist();
                Registry::getEntityManager()->flush();
                return $nrsolicmp;
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
}